// Include headers from OS
#include <joyos.h>
#include <math.h>


#define GYRO_PORT 23       
#define LSB_US_PER_DEG  1386466

#define LEFT_MOTOR 1
#define RIGHT_MOTOR 0
#define SPIN_MOTOR 2

#define LEFT_MOTOR_2 4
#define RIGHT_MOTOR_2 3
#define TURN_SPEED 100
#define TURN_PAUSE_INTERVAL 1

#define LM_FWD_SPEED 250 //decreased for testing was 250
#define RM_FWD_SPEED 250 //decreased for testing was 250

#define PROXIMITY_TO_HEADING 15 //Was 10

#define STRAIGHT_FWD_SPEED 220    // Was 200

#define HEADING_ERROR_TO_VEL_DIFF_FACTOR 3      // Was 1.5 //GAIN<<<<<<<<<<<<<<< -----was 3
#define TURNING_HEADING_ERROR_TO_VEL_FACTOR 1
#define HEADING_OFFSET_MOTOR_ADJUST_EVERY 0

#define TURNING_MAX_VEL 150
#define TURNING_MIN_VEL 75       // Was 75

#define LM_MOVE_SPEED 250
#define RM_MOVE_SPEED 250

#define STOP_TO_TURN_INTERVAL 1

#define PROXIMITY_TO_GOAL 100 //used to be 10 when we followed points

#define pi M_PI

#define HEADING_TOLERANCE_BEFORE_RESET_DIR 60 //used to be 60

#define ZERO centers[0]
#define ONE centers[1]
#define TWO centers[2]
#define THREE centers[3]
#define FOUR centers[4]
#define FIVE centers[5]

#define TEAM_NUMBER 18


int REVERSE;
int wantGearBox;
int wantBingBong;
int in_position; //is 1 when robot is in position, is 0 when robot is travelling to a position


double DesiredHeading; //robot's desired heading
double robotHeading; // robot's current heading


typedef struct point{
	int x;
	int y;
} Point;


Point centers[6]; // an array that has the six points of the centers of the six regions
Point gear_boxes[6];
Point bing_bong[6];

Point robot; //will carry robot's current position
Point desiredPosition; //will carry robot's desired position


void turnHeadToHeading(double heading, int speed);
double proximity_and_remainder360(double a, double b);
void moveFwd(int time);
void moveInSquare(int sidetime);
double fix0to360(double thing);
void getHeading();
void turnCt(int time, int speed);
void turnCCt(int time, int speed);
void motorsStartC(int speed);
void motorsStartCC(int speed);
void motorsStop();
void spinMotorStop();
void spinMotorRun();
void moveStraight(int time, int fwdSpeed, double heading);
int fixMotorVel(double vel);
double distanceFromTo(Point robot, Point goal);
void followPoints(Point robot, Point goal);
double calculateHeading(Point robot, Point goal);
double fixHeading180(double heading);
double fixHeadingProximity(double a, double b);
int turnCorCC(double goalMinusCurrent);
int calculateTurnMotorVelFromError(double errorc);
int closerRegions(int regions[]);
int shortestPath(int region,int desiredRegion);
void mockNumberTwo();
void init_centers();
void init_gear_boxes();
void init_bing_bong_balls();
void dumpBalls();
void goGetBalls(int r);
void goTurnGearbox(int region);
int fix05(int n);
void updateRobotPosition();
void turnAssToHeading(double headingtTH, int speed);
void moveBackwardsToPoint(Point goal);
void updateRobot();
int getRegionFromAngle(double ang);
int isInPosition(Point position, int proximity);
Point convertRegionToPoints(int region);
void moveToRegion(int desiredRegion);
int whichDumpRegion(int reg);
void setupSides();
void rightMotor(int vel);
void leftMotor(int vel);

extern volatile uint8_t robot_id;

